/*

------------------------------------------------------------------------------

A license is hereby granted to reproduce this software source code and
to create executable versions from this source code for personal,
non-commercial use.  The copyright notice included with the software
must be maintained in all copies produced.

THIS PROGRAM IS PROVIDED "AS IS". THE AUTHOR PROVIDES NO WARRANTIES
WHATSOEVER, EXPRESSED OR IMPLIED, INCLUDING WARRANTIES OF
MERCHANTABILITY, TITLE, OR FITNESS FOR ANY PARTICULAR PURPOSE.  THE
AUTHOR DOES NOT WARRANT THAT USE OF THIS PROGRAM DOES NOT INFRINGE THE
INTELLECTUAL PROPERTY RIGHTS OF ANY THIRD PARTY IN ANY COUNTRY.

Copyright (c) 1994-2004, John Conover, All Rights Reserved.

Comments and/or bug reports should be addressed to:

    john@email.johncon.com (John Conover)

------------------------------------------------------------------------------

tsbinary.c generates a sequence of binary numbers with the length of
the binary words specified as the single argument on the command line.

*/

#include <stdio.h>
#include <stdlib.h>


#ifdef __STDC__

    void binary (char *array, char *position);

#else

    void binary ();

#endif

#ifdef __STDC__

int main (int argc,char *argv[])

#else

int main (argc,argv)
int argc;
char *argv[];

#endif

{
    char *array, /* the array of a binary number */
         *position; /* reference to a character in the array of a binary number */

    int len, /* the length of the binary number */
        i, /* index into the array of a binary number */
        retval = 1; /* return value */

    if (argc > 1) /* enough arguments */
    {

        if ((len = atoi (argv[1])) > 0) /* length of binary numbers */
        {

            if ((array = malloc ( (size_t) (len + 1) * sizeof (char))) != (char *) 0) /* allocate the array of a binary number */
            {

                for (i = 0; i < len; i ++) /* initialize the binary number to zero - 1 */
                {
                    array[i] = (char) '1';
                }

                array[i] = (char) '\0'; /* terminate the array of a binary number */
                position = array; /* initialize the reference to a character in the array of a binary number */
                binary (array, position); /* generate the sequence of binary numbers */
                retval = 0; /* assume no errors */
            }

        }

    }

    if (retval != 0) /* any errors? */
    {
        (void) fprintf (stderr, "Generate a series of binary numbers\n    %s n, n = length of binary words\n", argv[0]); /* yes, print help */
    }

    exit (retval);

#ifdef LINT

    return (0); /* for lint formalities */

#endif

}

/*

void binary (char *array, char *position);

Recursive routine to generate a sequence of binary numbers; keeps
calling its self until it finds an EOS character.

*/

#ifdef __STDC__

void binary (char *array, char *position)

#else

void binary (array, position)
char *array;
char *position;

#endif

{
    int i;

    if (*position == (char) '\0') /* end of the array of a binary number? */
    {
        (void) printf ("%s\n", array); /* yes, print the array, (or anything else of all possible combinations of two things) */
    }

    else
    {

        for (i = 0; i < 2; i ++) /* for each of the two binary digits */
        {
            *position = (*position == (char) '0') ? (char) '1' : (char) '0'; /* if its a zero, make it a one; if its one, make it a zero */
            binary (array, position + 1); /* not at the EOS character, recurse */
        }

    }

}
